action.yml 8.1 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206
  1. # NOTE: Do not rely on `make` commands here as this action is used across different repos
  2. # where the Makefile will not be available
  3. name: 'Sentry Setup'
  4. description: 'Sets up a Sentry test environment'
  5. inputs:
  6. workdir:
  7. description: 'Directory where the sentry source is located'
  8. required: false
  9. default: '.'
  10. snuba:
  11. description: 'Is snuba required?'
  12. required: false
  13. default: 'false'
  14. clickhouse:
  15. description: 'Is clickhouse required?'
  16. required: false
  17. default: 'false'
  18. kafka:
  19. description: 'Is kafka required?'
  20. required: false
  21. default: 'false'
  22. chartcuterie:
  23. description: 'Is chartcuterie required?'
  24. required: false
  25. default: 'false'
  26. bigtable:
  27. description: 'Is bigtable required?'
  28. required: false
  29. default: 'false'
  30. python-version:
  31. description: 'python version to install'
  32. required: false
  33. default: '3.8.16'
  34. pg-version:
  35. description: 'PostgreSQL version to use'
  36. default: '14'
  37. required: false
  38. outputs:
  39. yarn-cache-dir:
  40. description: 'Path to yarn cache'
  41. value: ${{ steps.config.outputs.yarn-cache-dir }}
  42. acceptance-dir:
  43. description: 'Path to acceptance visual snapshot artifacts'
  44. value: ${{ steps.config.outputs.acceptance-dir }}
  45. matrix-instance-number:
  46. description: 'The matrix instance number (starting at 1)'
  47. value: ${{ steps.config.outputs.matrix-instance-number }}
  48. matrix-instance-total:
  49. description: 'Reexport of MATRIX_INSTANCE_TOTAL.'
  50. value: ${{ steps.config.outputs.matrix-instance-total }}
  51. runs:
  52. using: 'composite'
  53. steps:
  54. - name: Setup default environment variables
  55. # the default for "bash" is:
  56. # bash --noprofile --norc -eo pipefail {0}
  57. shell: bash --noprofile --norc -eo pipefail -ux {0}
  58. env:
  59. MATRIX_INSTANCE: ${{ matrix.instance }}
  60. # XXX: We should be using something like len(strategy.matrix.instance) (not possible atm)
  61. # If you have other things like python-version: [foo, bar, baz] then the sharding logic
  62. # isn't right because job-total will be 3x larger and you'd never run 2/3 of the tests.
  63. # MATRIX_INSTANCE_TOTAL: ${{ strategy.job-total }}
  64. run: |
  65. echo "PIP_DISABLE_PIP_VERSION_CHECK=on" >> $GITHUB_ENV
  66. echo "PIP_INDEX_URL=https://pypi.devinfra.sentry.io/simple" >> $GITHUB_ENV
  67. echo "SENTRY_SKIP_BACKEND_VALIDATION=1" >> $GITHUB_ENV
  68. ### node configuration ###
  69. echo "NODE_ENV=development" >> $GITHUB_ENV
  70. echo "NODE_OPTIONS=--max-old-space-size=4096" >> $GITHUB_ENV
  71. ### pytest configuration ###
  72. echo "PY_COLORS=1" >> "$GITHUB_ENV"
  73. echo "PYTEST_ADDOPTS=--reruns=5 --durations=10 --fail-slow=60s" >> $GITHUB_ENV
  74. ### pytest-sentry configuration ###
  75. if [ "$GITHUB_REPOSITORY" = "getsentry/sentry" ]; then
  76. echo "PYTEST_SENTRY_DSN=https://6fd5cfea2d4d46b182ad214ac7810508@sentry.io/2423079" >> $GITHUB_ENV
  77. echo "PYTEST_SENTRY_TRACES_SAMPLE_RATE=0" >> $GITHUB_ENV
  78. # This records failures on master to sentry in order to detect flakey tests, as it's
  79. # expected that people have failing tests on their PRs
  80. if [ "$GITHUB_REF" = "refs/heads/master" ]; then
  81. echo "PYTEST_SENTRY_ALWAYS_REPORT=1" >> $GITHUB_ENV
  82. fi
  83. fi
  84. # Configure a different release version, otherwise it defaults to the
  85. # commit sha which will conflict with our actual prod releases. This is a
  86. # confusing experience because it looks like these are "empty" releases
  87. # because no commits are attached and associates the release with our
  88. # javascript + sentry projects.
  89. echo "SENTRY_RELEASE=ci@$GITHUB_SHA" >> $GITHUB_ENV
  90. # this handles pytest test sharding
  91. if [ "$MATRIX_INSTANCE" ]; then
  92. if ! [ "${MATRIX_INSTANCE_TOTAL:-}" ]; then
  93. echo "MATRIX_INSTANCE_TOTAL is required."
  94. exit 1
  95. fi
  96. echo "TEST_GROUP=$MATRIX_INSTANCE" >> $GITHUB_ENV
  97. echo "TOTAL_TEST_GROUPS=$MATRIX_INSTANCE_TOTAL" >> $GITHUB_ENV
  98. fi
  99. - uses: getsentry/action-setup-venv@9e3bbae3836b1b6f129955bf55a19e1d99a61c67 # v1.0.5
  100. with:
  101. python-version: ${{ inputs.python-version }}
  102. cache-dependency-path: ${{ inputs.workdir }}/requirements-dev-frozen.txt
  103. install-cmd: pip install -r ${{ inputs.workdir }}/requirements-dev-frozen.txt
  104. - name: Set up outputs
  105. id: config
  106. env:
  107. MATRIX_INSTANCE: ${{ matrix.instance }}
  108. shell: bash --noprofile --norc -eo pipefail -ux {0}
  109. run: |
  110. echo "yarn-cache-dir=$(yarn cache dir)" >> "$GITHUB_OUTPUT"
  111. echo "matrix-instance-number=$(($MATRIX_INSTANCE+1))" >> "$GITHUB_OUTPUT"
  112. echo "matrix-instance-total=$((${MATRIX_INSTANCE_TOTAL:-}))" >> "$GITHUB_OUTPUT"
  113. echo "acceptance-dir=.artifacts/visual-snapshots/acceptance" >> "$GITHUB_OUTPUT"
  114. - name: Install python dependencies
  115. shell: bash --noprofile --norc -eo pipefail -ux {0}
  116. env:
  117. # This is necessary when other repositories (e.g. relay) want to take advantage of this workflow
  118. # without needing to fork it. The path needed is the one where setup.py is located
  119. WORKDIR: ${{ inputs.workdir }}
  120. run: |
  121. cd "$WORKDIR"
  122. # We need to install editable otherwise things like check migration will fail.
  123. SENTRY_LIGHT_BUILD=1 pip install --no-deps -e .
  124. - name: Start devservices
  125. shell: bash --noprofile --norc -eo pipefail -ux {0}
  126. env:
  127. NEED_KAFKA: ${{ inputs.kafka }}
  128. NEED_SNUBA: ${{ inputs.snuba }}
  129. NEED_CLICKHOUSE: ${{ inputs.clickhouse }}
  130. NEED_BIGTABLE: ${{ inputs.bigtable }}
  131. NEED_CHARTCUTERIE: ${{ inputs.chartcuterie }}
  132. WORKDIR: ${{ inputs.workdir }}
  133. PG_VERSION: ${{ inputs.pg-version }}
  134. ENABLE_AUTORUN_MIGRATION_SEARCH_ISSUES: '1'
  135. run: |
  136. sentry init
  137. # redis, postgres are needed for almost every code path.
  138. services='redis postgres'
  139. if [ "$NEED_CLICKHOUSE" = "true" ] || [ "$NEED_SNUBA" = "true" ]; then
  140. services="${services} clickhouse"
  141. fi
  142. if [ "$NEED_SNUBA" = "true" ]; then
  143. services="${services} snuba"
  144. fi
  145. if [ "$NEED_BIGTABLE" = "true" ]; then
  146. echo "BIGTABLE_EMULATOR_HOST=127.0.0.1:8086" >> $GITHUB_ENV
  147. services="${services} bigtable"
  148. fi
  149. if [ "$NEED_CHARTCUTERIE" = "true" ]; then
  150. services="${services} chartcuterie"
  151. fi
  152. sentry devservices up $services &
  153. # TODO: Use devservices kafka. See https://github.com/getsentry/sentry/pull/20986#issuecomment-704510570
  154. if [ "$NEED_KAFKA" = "true" ]; then
  155. # This is *not* the production version. Unclear reason as to why this was chosen
  156. # https://github.com/getsentry/ops/blob/c823e62f930ecc6c97bb08898c71e49edc7232f6/cookbooks/getsentry/attributes/default.rb#L631
  157. docker run \
  158. --name sentry_zookeeper \
  159. -d --network host \
  160. -e ZOOKEEPER_CLIENT_PORT=2181 \
  161. confluentinc/cp-zookeeper:4.1.0 \
  162. &
  163. # This is the production version; do not change w/o changing it there as well
  164. # https://github.com/getsentry/ops/blob/c823e62f930ecc6c97bb08898c71e49edc7232f6/cookbooks/getsentry/attributes/default.rb#L643
  165. docker run \
  166. --name sentry_kafka \
  167. -d --network host \
  168. -e KAFKA_ZOOKEEPER_CONNECT=127.0.0.1:2181 \
  169. -e KAFKA_LISTENERS=INTERNAL://0.0.0.0:9093,EXTERNAL://0.0.0.0:9092 \
  170. -e KAFKA_ADVERTISED_LISTENERS=INTERNAL://127.0.0.1:9093,EXTERNAL://127.0.0.1:9092 \
  171. -e KAFKA_LISTENER_SECURITY_PROTOCOL_MAP=INTERNAL:PLAINTEXT,EXTERNAL:PLAINTEXT \
  172. -e KAFKA_INTER_BROKER_LISTENER_NAME=INTERNAL \
  173. -e KAFKA_OFFSETS_TOPIC_REPLICATION_FACTOR=1 \
  174. confluentinc/cp-kafka:5.1.2 \
  175. &
  176. fi
  177. wait
  178. docker ps -a
  179. # This is necessary when other repositories (e.g. relay) want to take advantage of this workflow
  180. # without needing to fork it. The path needed is the one where tools are located
  181. cd "$WORKDIR"
  182. python3 -u -S -m tools.devservices_healthcheck
  183. cd -